'****************************************************************
'       (  ,  DS18B20 )                                 
'         (   )
'     (  1* )                                             
'****************************************************************
Device 16F628A
Declare Xtal=4
Config  BODEN_OFF, BOREN_OFF, CP_OFF, DATA_CP_OFF, PWRTE_ON, WDT_OFF, LVP_OFF, MCLRE_ON, XT_OSC
TRISA = %11110111
TRISB = %00000000
PORTB = %00000000
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''                                                                   
Declare  LCD_Type ALPHA   '   -  -
Declare  LCD_DTPin  PORTB.4   '   
Declare  LCD_ENPin  PORTB.0   '   E
Declare  LCD_RSPin  PORTB.2   '   RS
Declare  LCD_Interface  4   '   
Declare  LCD_CommandUs  200   '    
Declare  LCD_DataUs  50   '    
Declare  LCD_Lines   2   '   
Declare  CCP1_Pin PORTB.3
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Symbol T0IF = INTCON.2 ; TMR0 Overflow Interrupt Flag
Symbol T0IE = INTCON.5 ; TMR0 Overflow Interrupt Enable
Symbol GIE = INTCON.7  ; Global Interrupt Enable
Symbol MENU = PORTA.0
Symbol PLUS = PORTA.1
Symbol MINUS = PORTA.2
Symbol DQ = PORTA.4
OPTION_REG = %00000111
INTCON 	= %10100000
Dim BIG As Dword         '    
Dim BIG1 As BIG.HighWord
Dim R_Temp As Word 	'     
'   
Dim Temp As Float 	'    
'      
Dim TempIND As Float 	'      
' 
Dim C As Bit 	'     
'                                                  
Dim SECONDS  As Byte	 ;    
Dim MINUTES  As Byte	 ;      '
Dim HOUR     As Byte     ;         '
Dim TEXT     As Word
Dim M         As Byte
Dim A         As Byte
Dim B         As Byte
Dim R         As Byte
Dim D         As Byte
Dim N         As Byte
Dim U         As Byte
Dim W         As Byte
Dim XM        As Byte
Dim XL        As Byte
Dim t         As Bit
Print $FE,$40,$06,$09,$09,$06,$20,$20,$20,$20
Print At 1 ,1,$20,$20,$20,$20,$22,$41,$51,$55,$41,$22
Print At 2 ,1,$50,$52,$4F,$43,$45,$53,$49,$4E,$47,$2D,$30,$30,$31
DelayMS 1000
Cls
Clear
M = 0
XM = 24
XL = 23
N = 7
U = 0
W = 23
TEXT = $3A
BIG = 1000000 '   BIG 1000000      

    On_Interrupt GoTo MYINT
    GoTo main	            ;    

MYINT:                       ;  
    big1 = big1 -1 '       BIG1 
'  ,    65536  BIG ,     
    If BIG < 0 Then ' BIG < 0     
    BIG = BIG + 1000000 '     1000000
    Inc SECONDS
    t=~t
    EndIf
T0IF = 0	                '    TOIF  TMRO
Context Restore
main:
If SECONDS >= 60 Then SECONDS = 0:Inc MINUTES
If MINUTES >= 60 Then MINUTES = 0:Inc HOUR
If HOUR > 23 Then HOUR = 0
If MENU = 0 Then DelayMS 300:Inc M
If M > 4 Then M = 0
Branch M,[Izm,U_hour,U1_Tim_Vkl,U1_Tim_Vikl,U_Tem]
DelayMS 1
GoTo main
Izm:
Print At 1 ,1,Dec2 SECONDS,$20,$20,"MAX",Dec3 XM,$20,"MIN",Dec2 XL 
Print At 2 ,1,Dec2 HOUR,TEXT,Dec2 MINUTES,$20,$20,$20,Dec1 TempIND,$20,"C",8,$20,$20
DelayMS 50
If HOUR = N Then PORTB.3 = 1
If HOUR = W Then PORTB.3 = 0
'If HOUR = N Then HPWM PORTB.3,U,600:If SECONDS = 0 Or SECONDS = 10 Or SECONDS = 20 Or SECONDS = 30 Or SECONDS = 40 Or SECONDS = 50 Then Inc U
'If U >= 254 Then U = 254
'If HOUR = W Then HPWM PORTB.3,U,600:If SECONDS = 0 Or SECONDS = 10 Or SECONDS = 20 Or SECONDS = 30 Or SECONDS = 40 Or SECONDS = 50 Then Dec U
'If U >= 255 Then U = 0
If t=0 Then
    OWrite DQ, 1, [$CC,$44]  '   DS18S20    
    Print At 2 ,1,Dec2 HOUR,TEXT,Dec2 MINUTES,$20,$20,$20,Dec1 TempIND,$20,"C",0,$20,$20
    TEXT = $20    
Else
    OWrite DQ, 1, [$CC,$BE]  '       DS18S20   
    DelayMS 25
    ORead DQ, 2, [R_Temp.LowByte, R_Temp.HighByte]  '            R_Temp  Dword,    R_Temp.LowByte     R_Temp.HighByte 
    Temp = R_Temp     
    TempIND = Temp /16   '    If R_Temp > 64654 Then TempIND = Temp / 16 - 4095.93 '   -     
    TEXT = $3A
EndIf 
If TempIND >= 102 Or TempIND < 0 Then GoSub Er1
GoSub Prov
GoTo main
U_hour:
Cls
If PLUS = 0 Then DelayMS 20:Inc HOUR
If HOUR > 23 Then HOUR = 0
If MINUS = 0 Then DelayMS 20:Inc MINUTES
If MINUTES >= 60 Then MINUTES = 0
Print At 1 ,1,$AB,$41,$43,$AE
Print At 2 ,1,Dec2 HOUR,":",Dec2 MINUTES
If MENU = 0 Then DelayMS 100:Cls:M = 2:GoTo U1_Tim_Vkl
DelayMS 300
Cls
GoTo U_hour
U1_Tim_Vkl:
Cls
If PLUS = 0 Then DelayMS 20:Inc A
If A > 23 Then A = 0
If MINUS = 0 Then DelayMS 20:Inc B
If B >= 60 Then B = 0
Print At 1 ,1,$31,$20,$A8,$50,$20,$20,$20,$20,$20,$20,$20,$42,$4B,$A7
Print At 2 ,6,Dec2 A,":",Dec2 B
DelayMS 300
If MENU = 0 Then DelayMS 20:Cls:M = 3:GoTo U1_Tim_Vikl
GoTo U1_Tim_Vkl
U1_Tim_Vikl:
Cls
If PLUS = 0 Then DelayMS 20:Inc R
If R > 23 Then R = 0
If MINUS = 0 Then DelayMS 20:Inc D
If D >= 60 Then D = 0
Print At 1 ,1,$31,$20,$A8,$50,$20,$20,$20,$20,$20,$20,$20,$42,$AE,$4B,$A7
Print At 2 ,6,Dec2 R,":",Dec2 D
DelayMS 300
If MENU = 0 Then DelayMS 20:Cls:M = 4:GoTo U_Tem
GoTo U1_Tim_Vikl
Prov:
If HOUR = A And MINUTES = B Then PORTA.3 = 1
If HOUR = R And MINUTES = D Then PORTA.3 = 0
If TempIND <= XL Then PORTB.1 = 1
If TempIND >= XM Then PORTB.1 = 0
Return
U_Tem:
Print At 1 ,1,$A9,$63,$BF,$61,$BD,$6F,$B3,$BA,$61,$20,$20,"t",$20,"C",8
Print At 2 ,1,$20,$4D,$61,$78,$20,Dec3 XM,$20,$4D,$69,$6E,$20,Dec2 XL,$20,$20
DelayMS 300
If PLUS = 0 Then DelayMS 20:Inc XM
If XM >= 101 Then XM = 1
If MINUS = 0 Then DelayMS 20:Inc XL
If XL > XM Then XL = XM - 1
If MENU = 0 Then DelayMS 300:Cls:M = 0:GoTo main
GoTo U_Tem
Er1:
DelayMS 300
Cls
Print At 1 ,1,$54,$45,$4D,$A8,$45,$50,$41,$54,$A9,$50,$41
Print At 2 ,1,$48,$45,$20,$42,$20,$E0,$A5,$41,$A8,$41,$A4,$4F,$48,$45
DelayMS 1000
Cls
Print At 1 ,1,$A5,$A7,$A5,$20,$48,$45,$A5,$43,$A8,$50,$41,$42,$48,$AE,$A6
Print At 2 ,1,$20,$E0,$41,$54,$AB,$A5,$4B,$20,$44,$53,$31,$38,$42,$32,$30
DelayMS 1000
Cls
Return
End
